;------------------------------------------------------------------------------
; AutoHotkey Version: 1.x
; Language:       English
; Platform:       Win9x/NT
; Author:         Steffen Heldt 
;
; Script Function:
;   Log keystrokes and pass resulting string to Unit Converter
;
;------------------------------------------------------------------------------

; Determine AHK 
; -------------
if A_PtrSize = 4
{
  ;MsgBox 32-bit AutoHotkey_L!
  AHKL = True
}
else if A_PtrSize = 8
{
  ;MsgBox 64-bit AutoHotkey_L!
  AHKL = True
}
else
{
  ;MsgBox Unknown AutoHotkey version (maybe Basic)!
  AHKL = False
}

; For high speed
; --------------
SetBatchLines, -1
Process, Priority, , High
  
; Only one instance of this script is allowed
; -------------------------------------------
#SingleInstance force

; Recommended for performance and compatibility with future AutoHotkey releases.
; ------------------------------------------------------------------------------
#NoEnv 

; Set language of keyboard layout
; -------------------------------
nargs=%0%
defaultidle = %1%
defaulturl = %2%
defaultcompact = %3%
unitsets = %4%
defaultunitset = %5%
if (nargs > 6)
{
  lwnddec = %6%
  if (lwnddec <> "|more")
  {
    lwndhex := Dec2hex(lwnddec)	
    if (lwndhex <> "")
    {
      DllCall("user32.dll\ActivateKeyboardLayout", "uint", lwndhex, "uint", flag)
      ;TrayTip, Language, %lwndhex%, 20, 17
    }
  }
}
;MsgBox %defaultidle% %defaulturl% %defaultcompact% %unitsets% %defaultunitset% %lwnddec%

; Unconditional use of keyboard hook
; ----------------------------------
#InstallKeybdHook
#UseHook

; Recommended for new scripts due to its superior speed and reliability.
; ----------------------------------------------------------------------
SendMode Input 

; Detect hidden windows since they can be active (e.g. AutoHotkey main window while using Menu,MenuName,Show.)
; ----------------------------------------------
DetectHiddenWindows, On

; Initialize string for logging purpose
; -------------------------------------
LogVar=

; Tray menu
; ---------
IconPath=bin\exec.ico
Idle:=false
NoURLLookup:=false
CompactNotation:=false
Menu, Behavior, add, Idle
Menu, Behavior, add, URL lookup, NoURLLookup
Menu, Behavior, add, Compact notation, CompactNotation
if (unitsets = "None")
{
  Menu, Unitsets, add, No unit sets specified!, Nounitsets
}
else
{
  Loop, parse, unitsets, `,
  {
    Menu, Unitsets, add, %A_LoopField%, Unitsets
	if (A_LoopField = defaultunitset)
	{
      menu, Unitsets, Check, %A_LoopField%
	}
  }
}
Menu, Open, add, Log file, Logfile
Menu, Open, add, Journal, Journal
Menu, Open, add, Unit table, Units
Menu, Open, add, Prefix table, Prefixes
Menu, Open, add, Config file, Config
Menu, Tray, Icon, %IconPath%
Menu, Tray, Tip, Unit Scout`nRight-click for menu
Menu, Tray, NoStandard 
Menu, tray, add, Help
Menu, tray, add, About
Menu, tray, add, Database
Menu, tray, add, Behavior..., :Behavior
Menu, tray, add, Unit sets..., :Unitsets
Menu, tray, add, Open..., :Open
Menu, tray, add, Restart
Menu, tray, add, Quit
if (AHKL = "True")
{
  Menu, tray, Icon, Help, .\bin\Book.png, , 0
  Menu, tray, Icon, About, .\bin\About.png, , 0
  Menu, tray, Icon, Database, .\bin\Lambda.png, , 0
  Menu, tray, Icon, Behavior..., .\bin\Spanner.png, , 0
  Menu, tray, Icon, Unit sets..., .\bin\Target.png, , 0
  Menu, tray, Icon, Open..., .\bin\Open.png, , 0
  Menu, tray, Icon, Restart, .\bin\Refresh.png, , 0
  Menu, tray, Icon, Quit, .\bin\Cancel.png, , 0
}
if (defaultidle = "True")
{ 
  menu, Behavior, Check, Idle
  Idle:=true
}
if (defaulturl = "True")
{ 
  menu, Behavior, Check, URL lookup
  NoURLLookup:=true
}
if (defaultcompact = "True")
{ 
  menu, Behavior, Check, Compact notation
  CompactNotation:=true
}

; Detect change in keyboard language
; ----------------------------------
Gui +LastFound
hWnd := WinExist()
DllCall( "RegisterShellHookWindow", UInt,hWnd )
MsgNum := DllCall( "RegisterWindowMessage", Str,"SHELLHOOK" )
OnMessage( MsgNum, "ShellMessage" )

; Key logging of (ANSI) ASCII characters
; --------------------------------------
Goto, Keylogger

; Key logging of special characters
; ---------------------------------
;Euro sign
~<^>!e::LogVar=%LogVar%
;Backspace
~backspace::Bkspc()

; Append clipboard content
; ------------------------
~^v up::AppendClipboard()

; Forgetting keys
; ---------------
~*enter::Forget()
~*lbutton::Forget()
~*rbutton::Forget()
~*pgdn::Forget()
~*pgup::Forget()
~*esc::Forget()
~*up::Forget()
~*down::Forget()
~*left::Forget()
~*right::Forget()
~*home::Forget()
~*end::Forget()
~*lwin::Forget()
~*rwin::Forget()
~*capslock::Forget()
~*tab::Forget()

; End keys
; --------
~space::PassToConverter(A_Space)

;Labels
;------
Keylogger:
k_ASCII = 33
Loop
{
  Transform, k_char, Chr, %k_ASCII%
  StringUpper, k_char_u, k_char
  StringLower, k_char_l, k_char
  if (k_char_u == k_char and k_char_l == k_char)
  {
    Hotkey, ~%k_char%, Record, UseErrorLevel
  }
  else if (k_char_l == k_char)
  {
    Hotkey, ~%k_char%, RecordL, UseErrorLevel
  }
  else
  {
    Hotkey, ~+%k_char%, Record2, UseErrorLevel
  }
  if k_ASCII = 255
    break
  k_ASCII++
}
return
Logfile:
Keyword=log>>
TriggerAction(Keyword)
return
Journal:
Keyword=journal>>
TriggerAction(Keyword)
return
Units:
Keyword=units>>
TriggerAction(Keyword)
return
Prefixes:
Keyword=prefixes>>
TriggerAction(Keyword)
return
Config:
Keyword=config>>
TriggerAction(Keyword)
return
Help:
Keyword=help>>
TriggerAction(Keyword)
return
About:
Keyword=about>>
TriggerAction(Keyword)
return
Database:
Keyword=database>>
TriggerAction(Keyword)
return
Idle:
Keyword=idle>>
TriggerAction(Keyword)
return
NoURLLookup:
Keyword=urllookup>>
TriggerAction(Keyword)
return
CompactNotation:
Keyword=compact>>
TriggerAction(Keyword)
return
Nounitsets:
return
Unitsets:
Keyword=unitset>>%A_ThisMenuItem%
TriggerAction(Keyword)
if (unitsets <> "None")
{
  Loop, parse, unitsets, `,
  {
    If (A_LoopField = A_ThisMenuItem) 
    {
      Menu, Unitsets, Check, %A_LoopField%    
    }
    else
    {
      Menu, Unitsets, Uncheck, %A_LoopField%    
    }
  }
}
return
Restart:
Keyword=restart>>
TriggerAction(Keyword)
return
Quit:
ExitApp, 0
return
Record:
  StringTrimLeft, k_ThisHotkey, A_ThisHotkey, 1
  LogVar=%LogVar%%k_ThisHotkey%
return
RecordL:
  StringTrimLeft, k_ThisHotkey, A_ThisHotkey, 1
  StringLower, k_ThisHotkey, k_ThisHotkey
  LogVar=%LogVar%%k_ThisHotkey%
return
Record2:
  StringTrimLeft, k_ThisHotkey, A_ThisHotkey, 2
  LogVar=%LogVar%%k_ThisHotkey%
return

; Functions
; ---------
TriggerAction(Keyword)
{
  global LogVar
  LogVar=%Keyword%
  PassToConverter(A_Space)
}
Bkspc()
{
  global LogVar
  StringLen, Len, LogVar
  If Len=1,
    LogVar=
  If Len>1,
    LenMOne:=Len-1
	StringMid, LogVar, LogVar, 1 , LenMOne
}
AppendClipboard()
{
  Var1=%Clipboard%
  StringReplace, Var2, Var1, `r`n, %A_SPACE%, All
  global LogVar
  LogVar=%LogVar%%Var2%
}
Forget()
{
  global LogVar
  LogVar=
}
PassToConverter(LastKey)
{
  global LogVar
  If (LogVar="idle>>")
  {
	global Idle
	Idle:=not Idle
	If Idle
	{
	  menu, Behavior, Check, Idle
	}
	Else
	{
	  menu, Behavior, Uncheck, Idle
	}
  }
  If (LogVar="urllookup>>")
  {
	global NoURLLookup
	NoURLLookup:=not NoURLLookup
	If NoURLLookup
	{
	  menu, Behavior, Check, URL lookup
	}
	Else
	{
	  menu, Behavior, Uncheck, URL lookup
	}
  }
  If (LogVar="compact>>")
  {
	global CompactNotation
	CompactNotation:=not CompactNotation
	If CompactNotation
	{
	  menu, Behavior, Check, Compact notation
	}
	Else
	{
	  menu, Behavior, Uncheck, Compact notation
	}
  }
  global LogVar
  Found=0
  Needle1=>>
  Needle2=<<
  IfInString, LogVar, %Needle1%
    Found=1
  IfInString, LogVar, %Needle2%
    Found=1
  If Found=1
  {
    FileAppend, %LogVar%%LastKey%`n, *
	Forget()
  }
  Else
  {
    Forget()
  }
  Needle3=exit>>
  IfInString, LogVar, %Needle3%
  {
    menu, tray, NoIcon
	ExitApp, 0
  }
}
ShellMessage( wParam,lParam )
{
  hwnd := WinExist("A")
  iwnd := DllCall("user32.dll\GetWindowThreadProcessId", "uint", hwnd)
  lwnd := DllCall("user32.dll\GetKeyboardLayout", "uint", iwnd, "uint") 
  WinGet, hpid, ID
  lpid := DllCall("GetKeyboardLayout", "uint", pid, "uint")
  if ((lwnd <> lpid) and (lwnd <> 0))
  {
	lwndhex := Dec2hex(lwnd)	
	if (lwndhex <> "")
	{
	  global LogVar
	  LogVar=keyboardlayout>>%lwndhex%
	  menu, tray, NoIcon
	  PassToConverter(A_Space)
	}
  }
}
Dec2hex(deci)
{
	if (deci = "")
	{
	  return
	}
	hexa = %deci%
	SetFormat, IntegerFast, hex
	hexa += 0  
	hexa .= ""  ; Necessary due to the "fast" mode.
	SetFormat, IntegerFast, d
	return hexa
}